/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: SimpleSourceUnmarshaller.java,v 950bc37500bd 2010/07/10 10:22:50 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.observation.semantic;

import javax.annotation.Nonnull;
import java.util.ArrayList;
import java.util.List;
import it.tidalwave.util.As;
import it.tidalwave.util.DefaultDisplayable;
import it.tidalwave.util.DefaultIdentifiable;
import it.tidalwave.util.NotFoundException;
import it.tidalwave.semantic.io.spi.StatementUnmarshallerSupport;
import it.tidalwave.bluebill.observation.simple.SimpleSource;
import it.tidalwave.semantic.io.impl.Converter;
import org.openrdf.model.Statement;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class SimpleSourceUnmarshaller extends StatementUnmarshallerSupport
  {
    @Override @Nonnull
    public As unmarshal (final @Nonnull List<Statement> statements, final @Nonnull Context context)
      {
        // TODO: what about retrieving the observationSet and calling findOrCreate(?)
        final List<Object> capabilities = new ArrayList<Object>();
        capabilities.add(new DefaultIdentifiable(Converter.valueToId(statements.get(0).getSubject())));

        try
          {
            final String displayName = findStatementWithPredicate(statements, Vocabulary.RDFS_LABEL).getObject().stringValue();
            capabilities.add(new DefaultDisplayable(displayName, "SimpleSource"));
          }
        catch (NotFoundException e)
          {
            // ok. no Displayable
          }

        addCapabilities(capabilities, statements, Vocabulary.FOAF_HOME_PAGE);

        return new SimpleSource(capabilities.toArray());
      }
  }
